/****************************************************************************/
/*                                                                          */
/*                         GNAT COMPILER COMPONENTS                         */
/*                                                                          */
/*                             A - S N A M E S                              */
/*                                                                          */
/*                              C Header File                               */
/*                                                                          */
/*                            $Revision: 1.73 $                             */
/*                                                                          */
/*          Copyright (C) 1992-1998 Free Software Foundation, Inc.          */
/*                                                                          */
/* GNAT is free software;  you can  redistribute it  and/or modify it under */
/* terms of the  GNU General Public License as published  by the Free Soft- */
/* ware  Foundation;  either version 2,  or (at your option) any later ver- */
/* sion.  GNAT is distributed in the hope that it will be useful, but WITH- */
/* OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License */
/* for  more details.  You should have  received  a copy of the GNU General */
/* Public License  distributed with GNAT;  see file COPYING.  If not, write */
/* to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, */
/* MA 02111-1307, USA.                                                      */
/*                                                                          */
/* GNAT was originally developed  by the GNAT team at  New York University. */
/* It is now maintained by Ada Core Technologies Inc (http://www.gnat.com). */
/*                                                                          */
/****************************************************************************/

/* This is the C file that corresponds to the Ada package specification
   Snames. It was created manually from the file snames.ads. */

/* Name_Id values */

#define Name_uParent		(First_Name_Id + 256 + 0)
#define Name_uTag		(First_Name_Id + 256 + 1)
#define Name_Off		(First_Name_Id + 256 + 2)
#define Name_Space		(First_Name_Id + 256 + 3)
#define Name_Time		(First_Name_Id + 256 + 4)
#define Name_uInit_Proc		(First_Name_Id + 256 + 5)
#define Name_uSize              (First_Name_Id + 256 + 6)

/* Define the function to return one of the numeric values below. Note
   that it actually returns a char since an enumeration value of less
   than 256 entries is represented that way in Ada.  The operand is a Chars
   field value.  */

#define Get_Attribute_Id snames__get_attribute_id
extern char Get_Attribute_Id PROTO ((int));

/* Define the numeric values for the attributes.  */

#define  Attr_Abort_Signal                   0
#define  Attr_Access                         1
#define  Attr_Address                        2
#define  Attr_Address_Size                   3
#define  Attr_Adjacent                       4
#define  Attr_Aft                            5
#define  Attr_Alignment                      6
#define  Attr_Asm_Input                      7
#define  Attr_Asm_Output                     8
#define  Attr_AST_Entry                      9
#define  Attr_Bit                           10
#define  Attr_Bit_Order                     11
#define  Attr_Bit_Position                  12
#define  Attr_Body_Version                  13
#define  Attr_Callable                      14
#define  Attr_Caller                        15
#define  Attr_Ceiling                       16
#define  Attr_Code_Address                  17
#define  Attr_Component_Size                18
#define  Attr_Compose                       19
#define  Attr_Constrained                   20
#define  Attr_Copy_Sign                     21
#define  Attr_Count                         22
#define  Attr_Default_Bit_Order             23
#define  Attr_Definite                      24
#define  Attr_Delta                         25
#define  Attr_Denorm                        26
#define  Attr_Digits                        27
#define  Attr_Elaborated                    28
#define  Attr_Emax                          29
#define  Attr_Enum_Rep                      30
#define  Attr_Epsilon                       31
#define  Attr_Exponent                      32
#define  Attr_External_Tag                  33
#define  Attr_First                         34
#define  Attr_First_Bit                     35
#define  Attr_Fixed_Value                   36
#define  Attr_Floor                         37
#define  Attr_Fore                          38
#define  Attr_Fraction                      39
#define  Attr_Has_Discriminants             40
#define  Attr_Identity                      41
#define  Attr_Image                         42
#define  Attr_Img                           43
#define  Attr_Input                         44
#define  Attr_Integer_Value                 45
#define  Attr_Large                         46
#define  Attr_Last                          47
#define  Attr_Last_Bit                      48
#define  Attr_Leading_Part                  49
#define  Attr_Length                        50
#define  Attr_Machine                       51
#define  Attr_Machine_Emax                  52
#define  Attr_Machine_Emin                  53
#define  Attr_Machine_Mantissa              54
#define  Attr_Machine_Overflows             55
#define  Attr_Machine_Radix                 56
#define  Attr_Machine_Rounds                57
#define  Attr_Machine_Size                  58
#define  Attr_Mantissa                      59
#define  Attr_Max                           60
#define  Attr_Max_Interrupt_Priority        61
#define  Attr_Max_Priority                  62
#define  Attr_Max_Size_In_Storage_Elements  63
#define  Attr_Maximum_Alignment             64
#define  Attr_Mechanism_Code                65
#define  Attr_Min                           66
#define  Attr_Model                         67
#define  Attr_Model_Emin                    68
#define  Attr_Model_Epsilon                 69
#define  Attr_Model_Mantissa                70
#define  Attr_Model_Small                   71
#define  Attr_Modulus                       72
#define  Attr_Null_Parameter                73
#define  Attr_Object_Size                   74
#define  Attr_Partition_Id                  75
#define  Attr_Passed_By_Reference           76
#define  Attr_Pos                           77
#define  Attr_Position                      78
#define  Attr_Pred                          79
#define  Attr_Range                         80
#define  Attr_Range_Length                  81
#define  Attr_Remainder                     82
#define  Attr_Round                         83
#define  Attr_Rounding                      84
#define  Attr_Safe_Emax                     85
#define  Attr_Safe_First                    86
#define  Attr_Safe_Large                    87
#define  Attr_Safe_Last                     88
#define  Attr_Safe_Small                    89
#define  Attr_Scale                         90
#define  Attr_Scaling                       91
#define  Attr_Signed_Zeros                  92
#define  Attr_Size                          93
#define  Attr_Small                         94
#define  Attr_Storage_Size                  95
#define  Attr_Storage_Unit                  96
#define  Attr_Succ                          97
#define  Attr_Tag                           98
#define  Attr_Terminated                    99
#define  Attr_Tick                         100
#define  Attr_Truncation                   101
#define  Attr_Type_Class                   102
#define  Attr_UET_Address                  103
#define  Attr_Unbiased_Rounding            104
#define  Attr_Unchecked_Access             105
#define  Attr_Universal_Literal_String     106
#define  Attr_Unrestricted_Access          107
#define  Attr_VADS_Size                    108
#define  Attr_Val                          109
#define  Attr_Valid                        110
#define  Attr_Value                        111
#define  Attr_Value_Size                   112
#define  Attr_Version                      113
#define  Attr_Wide_Image                   114
#define  Attr_Wide_Value                   115
#define  Attr_Wide_Width                   116
#define  Attr_Width                        117
#define  Attr_Word_Size                    118

#define  Attr_Output                       119
#define  Attr_Read                         120
#define  Attr_Write                        121

#define  Attr_Elab_Body                    122
#define  Attr_Elab_Spec                    123
#define  Attr_Storage_Pool                 124

#define  Attr_Base                         125
#define  Attr_Class                        126

/* Define the function to return one of the numeric values below.  Note
   that it actually returns a char since an enumeration value of less
   than 256 entries is represented that way in Ada.  The operand is a Chars
   field value.  */

#define Get_Pragma_Id snames__get_pragma_id
extern char Get_Pragma_Id PROTO ((int));

/* Define the numeric values for the pragmas. */

/* Configuration pragmas first */

#define  Pragma_C_Pass_By_Copy               0
#define  Pragma_Component_Alignment          1
#define  Pragma_Discard_Names                2
#define  Pragma_Eliminate                    3
#define  Pragma_Extend_System                4
#define  Pragma_Float_Representation         5
#define  Pragma_Locking_Policy               6
#define  Pragma_Long_Float                   7
#define  Pragma_Normalize_Scalars            8
#define  Pragma_Polling                      9
#define  Pragma_Propagate_Exceptions        10
#define  Pragma_Queuing_Policy              11
#define  Pragma_Restrictions                12
#define  Pragma_Reviewable                  13
#define  Pragma_Source_File_Name            14
#define  Pragma_Suppress                    15
#define  Pragma_Task_Dispatching_Policy     16
#define  Pragma_Unsuppress                  17
#define  Pragma_Use_VADS_Size               18
#define  Pragma_Warnings                    19

/* Remaining pragmas */

#define  Pragma_Abort_Defer                 20
#define  Pragma_Ada_83                      21
#define  Pragma_Ada_95                      22
#define  Pragma_All_Calls_Remote            23
#define  Pragma_Annotate                    24
#define  Pragma_Assert                      25
#define  Pragma_Asynchronous                26
#define  Pragma_Atomic                      27
#define  Pragma_Atomic_Components           28
#define  Pragma_Attach_Handler              29
#define  Pragma_Comment                     30
#define  Pragma_Common_Object               31
#define  Pragma_Complex_Representation      32
#define  Pragma_Controlled                  33
#define  Pragma_Convention                  34
#define  Pragma_CPP_Class                   35
#define  Pragma_CPP_Constructor             36
#define  Pragma_CPP_Destructor              37
#define  Pragma_CPP_Virtual                 38
#define  Pragma_CPP_Vtable                  39
#define  Pragma_Debug                       40
#define  Pragma_Elaborate                   41
#define  Pragma_Elaborate_All               42
#define  Pragma_Elaborate_Body              43
#define  Pragma_Export                      44
#define  Pragma_Export_Exception            45
#define  Pragma_Export_Function             46
#define  Pragma_Export_Object               47
#define  Pragma_Export_Procedure            48
#define  Pragma_Export_Valued_Procedure     49
#define  Pragma_Ident                       50
#define  Pragma_Import                      51
#define  Pragma_Import_Exception            52
#define  Pragma_Import_Function             53
#define  Pragma_Import_Object               54
#define  Pragma_Import_Procedure            55
#define  Pragma_Import_Valued_Procedure     56
#define  Pragma_Inline                      57
#define  Pragma_Inline_Generic              58
#define  Pragma_Inspection_Point            59
#define  Pragma_Interface                   60
#define  Pragma_Interface_Name              61
#define  Pragma_Interrupt_Handler           62
#define  Pragma_Interrupt_Priority          63
#define  Pragma_Linker_Alias                64
#define  Pragma_Linker_Options              65
#define  Pragma_Linker_Section              66
#define  Pragma_List                        67
#define  Pragma_Main_Storage                68
#define  Pragma_Machine_Attribute           69
#define  Pragma_Memory_Size                 70
#define  Pragma_No_Return                   71
#define  Pragma_Optimize                    72
#define  Pragma_Pack                        73
#define  Pragma_Page                        74
#define  Pragma_Passive                     75
#define  Pragma_Preelaborate                76
#define  Pragma_Priority                    77
#define  Pragma_Psect_Object                78
#define  Pragma_Pure                        79
#define  Pragma_Pure_Function               80
#define  Pragma_Remote_Call_Interface       81
#define  Pragma_Remote_Types                82
#define  Pragma_Share_Generic               83
#define  Pragma_Shared                      84
#define  Pragma_Shared_Passive              85
#define  Pragma_Source_Reference            86
#define  Pragma_Stream_Convert              87
#define  Pragma_Subtitle                    88
#define  Pragma_Suppress_All                89
#define  Pragma_Suppress_Initialization     90
#define  Pragma_System_Name                 91
#define  Pragma_Task_Info                   92
#define  Pragma_Task_Storage                93
#define  Pragma_Time_Slice                  94
#define  Pragma_Title                       95
#define  Pragma_Unchecked_Union             96
#define  Pragma_Unimplemented_Unit          97
#define  Pragma_Unreserve_All_Interrupts    98
#define  Pragma_Volatile                    99
#define  Pragma_Volatile_Components        100
#define  Pragma_Weak_External              101

/* The following are deliberately out of alphabetical order, see Snames */

#define  Pragma_AST_Entry                  102
#define  Pragma_Storage_Size               103
#define  Pragma_Storage_Unit               104

/* Define the numeric values for the conventions.  */

#define  Convention_Ada                      0
#define  Convention_Intrinsic                1
#define  Convention_Entry                    2
#define  Convention_Protected                3
#define  Convention_Assembler                4
#define  Convention_C                        5
#define  Convention_COBOL                    6
#define  Convention_CPP                      7
#define  Convention_Fortran                  8
#define  Convention_Stdcall                  9
#define  Convention_Stubbed                 10

/* End of a-snames.h (C version of Snames package spec) */
